package com.sky.ioc.mapper.meeting;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.sky.ioc.entity.domain.meeting.MeetingRecord;
import com.sky.ioc.entity.params.IocParam;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

@Mapper
public interface MeetingRecordMapper extends BaseMapper<MeetingRecord> {

    @Select("<script> " +
            "SELECT count(1) FROM meeting_record  where 1=1 " +
            "<if test='iocParam!=null and iocParam.timeRange != null '>" +
            "<![CDATA[ and start_time >= #{iocParam.timeRange.startDate} " +
            " AND end_time <= #{iocParam.timeRange.endDate} ]]> " +
            "</if>" +
            "<if test='iocParam!=null and iocParam.roomId != null '>" +
            " and room_id = #{iocParam.roomId} " +
            "</if>" +
            "</script>")
    Integer getTotalByTimeAndRoomId(@Param("iocParam") IocParam iocParam);
}
