package com.sky.ioc.service.Parking.impl;

import com.alibaba.fastjson.JSONObject;
import com.sky.ioc.entity.Indeicator;
import com.sky.ioc.entity.Label;
import com.sky.ioc.entity.Cake;
import com.sky.ioc.entity.domain.parking.Parking;
import com.sky.ioc.entity.params.IocParam;
import com.sky.ioc.mapper.ParkMapper;
import com.sky.ioc.mapper.ParkingMapper;
import com.sky.ioc.service.Parking.ParkingService;
import com.sky.ioc.tool.DateUtil;
import com.sky.ioc.tool.FalseData;
import com.sky.ioc.tool.GeneralMethod;
import com.sky.ioc.tool.ReturnMsg;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.DecimalFormat;
import java.util.*;
import java.util.concurrent.ThreadLocalRandom;

/**
 * TODO 智慧停车
 * @Description
 * @Author LunCe
 * @Date 2023/2/10 13:45
 **/
@Service
public class ParkingServiceImpl implements ParkingService {

    @Autowired
    ParkingMapper parkingMapper;

    @Autowired
    ParkMapper parkMapper;


    @Override
    public ReturnMsg getCoreIndicators(IocParam iocParam) {
        Indeicator indeicator = new Indeicator();
        List<JSONObject> objects = indeicator.getList();

      /*  Integer totalParking = parkingMapper.getTotalParkingByCompanyIdAndDeptId(iocParam);
        Integer totalPark = parkMapper.getTotalParkByCompanyIdAndDeptId(iocParam);
        Integer total = parkMapper.getTotalParkByCompanyIdAndDeptIdAndType(iocParam,1);//违停*/

        ThreadLocalRandom random = ThreadLocalRandom.current();
        int totalParking = 274;
        int dayParking = random.nextInt(150,170);
        int breakRuleParking = random.nextInt(0,10);
        int unParking = totalParking - dayParking;
        float compare = (float) Math.random();
        DecimalFormat decimalFormat = new DecimalFormat("#.0");
        compare = Float.parseFloat(decimalFormat.format(compare));
        objects.get(0).put("value",totalParking);
        objects.get(0).put("compare",compare);

        objects.get(1).put("value",dayParking);
        objects.get(1).put("compare",compare);

        objects.get(2).put("value",breakRuleParking);
        objects.get(2).put("compare",-compare);

        objects.get(3).put("value",unParking);
        objects.get(3).put("compare",compare);
        indeicator.setWorthAttention("⼀⻋⼀位不乱停");
        indeicator.setList(objects);
        return ReturnMsg.ok(indeicator);
    }

    @Override
    public ReturnMsg getTrafficflowSituation(IocParam iocParam) {
        String[] param = {"getInto","leave"};
        String startStr = iocParam.getTimeRange().getStartDate();
        String endStr = iocParam.getTimeRange().getEndDate();
        List<String> list = DateUtil.getBetweenDays(startStr, endStr);
        String[] labKey = list.toArray(new String[0]);
      //  String[] labKey = {"1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"};
        List<Label> labels1 = GeneralMethod.getInstance().dataGeneration(param, labKey);
        return ReturnMsg.ok(labels1);
    }

    @Override
    public ReturnMsg getVacantParkingSpace(IocParam iocParam) {
        return ReturnMsg.ok(FalseData.PARKINGLIST);
    }
    @Override
    public ReturnMsg getParkingSpaceDetails(IocParam iocParam) {
        //List<Parking> list = parkingMapper.getListByCompanyIdAndDeptId(iocParam);
        return ReturnMsg.ok(FalseData.PARKINGLIST);
    }


    @Override
    public ReturnMsg getStopViolation(IocParam iocParam) {
      //  List<Map<String,String>> lists = parkMapper.getListByCompanyIdAndDeptIdAndType(iocParam,1);
        List<Cake> list = new ArrayList<>();
        list.add(new Cake("郑分"));
        list.add(new Cake("北京规划院"));
        list.add(new Cake("中讯院"));
        list.add(new Cake("广分"));
        return ReturnMsg.ok(list);
    }

    @Override
    public ReturnMsg getOccupationOfParkingSpace(IocParam iocParam) {
        //List<Map<String,String>> lists = parkMapper.getListByCompanyIdAndDeptIdAndType(iocParam,null);
        List<Cake> list = new ArrayList<>();
        list.add(new Cake("郑分"));
        list.add(new Cake("北京规划院"));
        list.add(new Cake("中讯院"));
        list.add(new Cake("广分"));
        return ReturnMsg.ok(list);
    }


}
